/* ************************************************************************* * 
    Simplevaders space-invaders like game that is not like space-invaders
    Copyright (C) 2007  DusteD

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. 
 * ************************************************************************* */

/* Disclamer (2): This was my first computergame, my first experience with opengl,
   sdl and my first C++ program. I learned a lot from all the mistakes and 
   design-flaws I made here. So, go easy on me, I know there are lots of errors in
   here, but I only learn by doing, and by making mistakes. */

//FIXME: needz moar bullutz

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_mixer.h>
#include <SDL/SDL_image.h>
#include <math.h>
#include <string.h>

#define ALIEN_SHOOT_DELAY rand() % 5000/(level/5.0f);
#define NUM_PSYS 20
#define NUM_PARTICLES 50
#define NUM_BULLETS 200

using namespace std;
SDL_Surface *screen = NULL;
SDL_Surface *texture = NULL;

TTF_Font *font = NULL;
SDL_Surface *textureb = NULL;
SDL_Surface *welcomeimg = NULL;

SDL_Event event;

//sounds
bool sound=1;
Mix_Chunk *SND_playerbullet = NULL;
Mix_Chunk *SND_nmedie = NULL; 
Mix_Chunk *SND_gameover = NULL;
Mix_Chunk *SND_playerhit = NULL;

int bestScore=0;

int level=1;
int playerbullets=0;
int nextlevblocks=0;

int alienrows = 3;
#define aliensInrow 15
#define MAX_ALIEN_ROWS 5

void spawnbullet(GLfloat x, GLfloat y,bool dir);
float rndflt(float total, float negative);
void initGameObjects(bool ng);
void txt();
void exitgame(bool status);
void game_over();
void newgame();
void spawnPsystem(GLfloat x, GLfloat y, GLfloat scale, int life, GLfloat maxvel);
void renderParticlesystems();
void renderAlienRows();

long aRowLastTick=0;
int aRowTicks=0;

long drawLastTick;
bool glBlink=0;
bool glBlinkOff=0;
bool enablePs=1;

float scale = 0.4f;

bool starfield=1;
GLuint glTexture[5]; // 0 = score 1 = welcome 2 = gameover 3 = flare 4=credits
GLint glAlienMesh = 0;

//closeness = sqrt(pow(pos[0] - aliens[alienr].pos[0],2) + pow(pos[1] - aliens[alienr].pos[1],2));
class particleSystem {
public:
  int numparticles, liveparticles, life[NUM_PARTICLES];
  bool initialized,l[NUM_PARTICLES];
  GLfloat x[NUM_PARTICLES], y[NUM_PARTICLES], vel[NUM_PARTICLES], rot[NUM_PARTICLES], col[NUM_PARTICLES][3], scale,ox,oy,maxvel;
  long lastTick;
  int lifeTicks;
  int syslife;

  void init()
  {
    int p=0;
    if(liveparticles != 0)
    {
      cout << "trying to init live ps\n";
      exitgame(1);
    }
    while(p<numparticles)
    {
      x[p]=0.0f;
      y[p]=0.0f;
      rot[p]=rndflt(360,0);
      vel[p]=rndflt(maxvel,0)+0.1;
      l[p]=1;
      life[p]=rand() % syslife;
      col[p][0]=rndflt(1,0);
      col[p][1]=rndflt(1,0);
      col[p][2]=rndflt(1,0);
      p++;
    }
    liveparticles=p;
    lastTick=SDL_GetTicks();
    lifeTicks=lastTick;
    initialized=1;
  }
  
  void update()
  {
    int p=0;
    int ticks = SDL_GetTicks() - lastTick;
    GLfloat d;
    while(p<numparticles)
    {
      if(l[p])
      {
        d = vel[p] * (ticks / 1000.0f);
        
        x[p] = x[p]+d;
        //Nulstil cursor
        glLoadIdentity();
        //Roter
        GLfloat g = (1.f/rndflt(life[p],0))*(SDL_GetTicks() - lifeTicks);
  
        glTranslatef( ox, oy, -5.0 );
        glRotatef( rot[p],0.0,0.0,1.0 );
        glTranslatef( x[p],0.0,0.0);
        //Placer
        
        //Farv
        glColor4f( 1.0, 1.0-(g/2), 1.0f-g, 1.0f-g );
        //Tegn
        glEnable(GL_TEXTURE_2D);
        glBindTexture(GL_TEXTURE_2D, glTexture[3]);
        glEnable(GL_BLEND);
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
        glBegin ( GL_QUADS );
          glTexCoord2f(0.0f,-1.0f);glVertex3f(-0.1f*scale,  0.1f*scale, 0.0f);
          glTexCoord2f(1.0f,-1.0f);glVertex3f( 0.1f*scale,  0.1f*scale, 0.0f);
          glTexCoord2f(1.0f,0.0f); glVertex3f( 0.1f*scale, -0.1f*scale, 0.0f);
          glTexCoord2f(0.0f,0.0f); glVertex3f(-0.1f*scale, -0.1f*scale, 0.0f);
        glEnd();
        glDisable(GL_TEXTURE_2D);  
        glDisable(GL_BLEND);
        glPopMatrix();
        //Hvis den er død?
        if(x[p] > 3.0 || x[p] < -3.0 || y[p] > 3.0 || y[p] < -3.0 || (lifeTicks+life[p]) < SDL_GetTicks())
        {
          liveparticles--;
          l[p]=0;
        }
      }
      p++;
    }

    lastTick = SDL_GetTicks();
  }
};


particleSystem psys[NUM_PSYS];

/* function to reset our viewport after a window resize */
void resizeWindow( int width, int height )
{
    /* Height / width ration */
    GLfloat ratio;

    /* Protect against a divide by zero */
    if ( height == 0 )
      height = 1;

    ratio = ( GLfloat )width / ( GLfloat )height;

    /* Setup our viewport. */
    glViewport( 0, 0, ( GLsizei )width, ( GLsizei )height );

    /* change to the projection matrix and set our viewing volume. */
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity( );

    /* Set our perspective */
    gluPerspective( 45.0f, ratio, 0.1f, 100.0f );

    /* Make sure we're chaning the model view and not the projection */
    glMatrixMode( GL_MODELVIEW );

    /* Reset The View */
    glLoadIdentity();
}

class player {
  public:
  int lives;
  int health;
  GLfloat pos[3];
  long lastTick;
  long lastShotTick;
  GLfloat xvel;
  GLfloat yvel;
  bool shooting;
  int score;
  
  void stats()
  {
    txt();
  }
  
  void move()
  {
    int ticks;
    GLfloat xdistance,ydistance;

    ticks = SDL_GetTicks() - lastTick;
    lastTick = SDL_GetTicks();

    xdistance = xvel * (ticks / 1000.0f);
    pos[0] = pos[0] + xdistance;

    
    ydistance = yvel * (ticks / 1000.0f);
    pos[1] = pos[1] + ydistance;

    xvel=0.0f;
    yvel=0.0f;
    
    //keep player on screen
    if(pos[0] > 3.1 || pos[0] < -3.1)
      pos[0] = pos[0] - xdistance;
    if(pos[1] > 2.5 || pos[1] < -2.5)
      pos[1]=pos[1]-ydistance;

    glTranslatef( pos[0], pos[1], pos[2] );

    if(shooting)
    {
      if(SDL_GetTicks() - lastShotTick > 100)
      {
      if(playerbullets<6)
      {
        spawnbullet(pos[0],pos[1],1);
        lastShotTick=SDL_GetTicks();
        if(sound)
          Mix_PlayChannel( -1, SND_playerbullet, 0 );
        playerbullets++;
      }
      }
    }
  }

  void gethit()
  {
    lives--;
    glBlink=1;
    drawLastTick=SDL_GetTicks();
    stats();
    if(sound)
      Mix_PlayChannel(-1, SND_playerhit, 0);

    if(lives == 0)
    {
      game_over();
    }
  }
};

player playerobj;

class alienrow {
  private:
  float shootDelay[15];
  long lastShotTick[15];
  bool dir; //0 = <-- 1= -->
  public:
  bool nextrow;
  bool active;
  GLfloat x[15],y,xvel;
  bool live[15];

  void hit(int a)
  {
    live[a]=0;
    spawnPsystem(x[a],y-0.25,0.3,1000,1.0);
    playerbullets--;
    playerobj.score=playerobj.score+(3*level*level);
    playerobj.stats();
    if(playerobj.score > bestScore)
      bestScore = playerobj.score;
    if(sound)
      Mix_PlayChannel( -1, SND_nmedie, 0 );
  }

  void init(GLfloat starty, bool startdir)
  {
    GLfloat width = 0.5*scale;
    if(active != 1)
    { 
      int a=0;
      GLfloat offset=0.0f;
      GLfloat startx = -2.0f;
      active=1;
      dir = startdir;
      xvel = 10.2f*(level/50.0f);
      y = starty;
      nextrow=0;
     
      while(a < 15)
      {
        live[a] = 1;
        x[a] = startx + offset;
        shootDelay[a] = ALIEN_SHOOT_DELAY;
        lastShotTick[a] = SDL_GetTicks()-rand() % 250;
        offset = offset + width + 0.1;
        a++;
      }
    } else {
      cout << "Tried to initialize active row.\n";
      exitgame(1);
    }
  }
  
  void update()
  {
    int a=0;
    int tempdir=3;
    int livealiens=0;
    GLfloat d = xvel*((aRowTicks - aRowLastTick)/1000.0f);
    
    if(active==0)
      return;
    
    while(a<15)
    {
      if(live[a])
      {
        livealiens++;
        
        if(dir)
          x[a] = x[a] + d;
        else
          x[a] = x[a] - d;

        if(x[a] > 3.0f)
          tempdir=0;
        else if(x[a] < -3.0f)
          tempdir=1;
        
        glPushMatrix();
        glLoadIdentity();
        glTranslatef( x[a], y, -6.0f );
        glCallList(glAlienMesh);
        glPopMatrix();

        //Skyd
        if((SDL_GetTicks()-lastShotTick[a]) > shootDelay[a])
        {
          spawnbullet(x[a],y,0);
          lastShotTick[a] = SDL_GetTicks();
          shootDelay[a]=ALIEN_SHOOT_DELAY;
        }
        
        //Coldetc player
        GLfloat closeness = sqrt(pow(x[a] - playerobj.pos[0],2) + pow(y - playerobj.pos[1],2));
        if(closeness < 0.26)
        {
          hit(a);
          playerobj.score--;
          playerobj.gethit();
          playerobj.stats();
        }
        
      }
      a++;
    }
    
    if(tempdir<3)
    {
      dir=tempdir;
      nextrow=1;
    }
    if(livealiens==0)
    {
      active=0;
      nextrow=0;
    }
    //Game over?
    if(y < -2.2)
      game_over();
  }
};

alienrow arows[MAX_ALIEN_ROWS];

class bullet  {
  public:
  bool active;
  bool dir;
  float yvel;
  GLfloat pos[3];
  long lastTick;
  
  void move()
  {

      int ticks;
      GLfloat distance;
      
      ticks = SDL_GetTicks() - lastTick;
      distance = yvel * (ticks / 1000.0f);
      lastTick = SDL_GetTicks();
      
      if(dir == 0)
        pos[1] = pos[1] - distance; //0.001f;//distance;
        else
        pos[1] = pos[1] + distance; //0.001f;//distance;

      glTranslatef( pos[0], pos[1], pos[2] );

      if(dir == 0)
      {
        if(pos[1] < -2.5f)
        {
          active=0;
        }
      } else {
        if(pos[1] > 2.5f)
        {
          active=0;
          playerbullets--;
        }
      }

    //Collision detection med player
    if(pos[0] > playerobj.pos[0]-0.15f && pos[0] < playerobj.pos[0]+0.15f && pos[1] < playerobj.pos[1]+0.25f  && pos[1] > playerobj.pos[1]-0.25f && dir==0)
    {
      playerobj.gethit();
      active=0;
    } else if(dir==1) {
    
      //Gå alle aliens igennem
      int ar=0;
      while(ar < alienrows)
      {
        if(arows[ar].active == 1)
        {
          int a=0;
          while(a < aliensInrow)
          {
            if(arows[ar].live[a] == 1)
            {
              if(pos[0] > arows[ar].x[a]-0.18 && pos[0] < arows[ar].x[a]+0.18 && pos[1] > arows[ar].y-0.18 && pos[1] < arows[ar].y+0.18 ) //HACK virker ikke med scale
              {
                arows[ar].hit(a);
                active=0;
              }
            }
            a++;
          }
        }
        ar++;
      }
    }
  }
};


bullet bullets[NUM_BULLETS];

void spawnbullet(GLfloat x, GLfloat y,bool dir)
{
  int thisbullet=0;
  //Loop gennem vores bullets til vi finder en der ikke er aktiv
  while(thisbullet != NUM_BULLETS)
  {
    if(bullets[thisbullet].active != 1)
    {
      bullets[thisbullet].active = 1;
      bullets[thisbullet].pos[0] = x;
      bullets[thisbullet].dir=dir;
      if(dir==1)
      {
        bullets[thisbullet].yvel=3.5f;
        bullets[thisbullet].pos[1] = y +0.25f;
       } else {
        bullets[thisbullet].yvel=1.5f;
        bullets[thisbullet].pos[1] = y-0.1f;
      }
      bullets[thisbullet].lastTick = SDL_GetTicks();
      break;
    }
    thisbullet++;
  }

}

//lists

GLint glAlienBulletMesh = 1;
//GLint glPlayerMesh = 2 ;
GLint glPlayerBullet = 3;
//GLint glScores = 4;




void initGLobjects()
{


  glAlienMesh = glGenLists(1);
  glNewList(glAlienMesh, GL_COMPILE);
    glColor3f(1.0f,0.0f,0.0f);
    glBegin( GL_TRIANGLES );
    
      glVertex3f( -0.25f*scale,0.25f*scale,0.0f*scale );
      glVertex3f( 0.25f*scale,0.25f*scale,0.0f*scale );
      glColor3f(1.0f,1.0f,0.0f);
      glVertex3f( 0.0*scale, -0.25*scale,0.0f*scale );

      glColor3f(1.0f,0.0f,0.0f);
      
      glVertex3f( -0.30f*scale,0.35f*scale,0.0f*scale );
      glVertex3f( -0.25f*scale,0.25f*scale,0.0f*scale );
      glVertex3f( 0.0f*scale,0.25f*scale,0.0f*scale );


      glVertex3f( 0.30f*scale,0.35f*scale,0.0f*scale );
      glVertex3f( 0.25f*scale,0.25f*scale,0.0f*scale );
      glVertex3f( 0.0f*scale,0.25f*scale,0.0f*scale );
    glEnd( );
  glEndList();

  glAlienBulletMesh = glGenLists(1);
  glNewList(glAlienBulletMesh, GL_COMPILE);
    glBegin( GL_TRIANGLES );
      glColor3f(1.0f,1.0f,1.0f);
      glVertex3f( -0.015f, 0.015f,0.0f );
      glVertex3f( 0.015f, 0.015f,0.0f);
      glVertex3f( 0.0f, -0.030f, 0.0f);
    glEnd( );
  glEndList();

  //Player bullet mesh (glPlayerBullet)
  glPlayerBullet = glGenLists(1);
  glNewList(glPlayerBullet, GL_COMPILE);
    glBegin( GL_TRIANGLES );
      glColor3f(0.0f,1.0f,0.0f);
      glVertex3f( 0.0f, 0.03f, 0.0f );
      glColor3f(1.0f,1.0f,1.0f);
      glVertex3f( -0.02f, -0.025f, 0.0f);
      glVertex3f(  0.02f, -0.025f, 0.0f);
    glEnd( );
  glEndList();

  //Texturer
  welcomeimg = IMG_Load("data/intro.png");
  
  if(welcomeimg == NULL)
    exitgame(1);

  glGenTextures(1, &glTexture[1]);
  glBindTexture(GL_TEXTURE_2D, glTexture[1]);
    gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA, welcomeimg->w, welcomeimg->h, GL_RGBA, GL_UNSIGNED_BYTE, welcomeimg->pixels);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

  //Texturer
  welcomeimg = IMG_Load("data/gameover.png");
  
  if(welcomeimg == NULL)
    exitgame(1);

  glGenTextures(1, &glTexture[2]);
  glBindTexture(GL_TEXTURE_2D, glTexture[2]);
    gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA, welcomeimg->w, welcomeimg->h, GL_RGBA, GL_UNSIGNED_BYTE, welcomeimg->pixels);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

  //Texturer
  welcomeimg = IMG_Load("data/flare.png");
  
  if(welcomeimg == NULL)
    exitgame(1);

  glGenTextures(1, &glTexture[3]);
  glBindTexture(GL_TEXTURE_2D, glTexture[3]);
    gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA, welcomeimg->w, welcomeimg->h, GL_RGBA, GL_UNSIGNED_BYTE, welcomeimg->pixels);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

  //Texturer
  welcomeimg = IMG_Load("data/cred.png");
  
  if(welcomeimg == NULL)
    exitgame(1);

  glGenTextures(1, &glTexture[4]);
  glBindTexture(GL_TEXTURE_2D, glTexture[4]);
    gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA, welcomeimg->w, welcomeimg->h, GL_RGBA, GL_UNSIGNED_BYTE, welcomeimg->pixels);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

  SDL_FreeSurface( welcomeimg );

}

void initGameObjects(bool ng)
{
// Player
  playerobj.pos[0] = 0.0;
  playerobj.pos[1] = -2.20;
  
  playerobj.lastTick = SDL_GetTicks();
  if(ng)
  {
    playerobj.score = 0;
    playerobj.lives = 3;
  }
  playerobj.stats();

//Bullets
  int thisbullet = 0;
  while(thisbullet != NUM_BULLETS)
  {
    bullets[thisbullet].lastTick = SDL_GetTicks();
    bullets[thisbullet].active = 0;
    thisbullet++;
  }

  int ar=0;
  GLfloat yofs=2.2;
  
  while(ar < alienrows)
  {
    arows[ar].active=0;
    arows[ar].init(yofs, 1);
    yofs=yofs-0.25f;
    ar++;
  }
  aRowLastTick=SDL_GetTicks(); //HACK

}

void initTxt()
{
  if(!font)
  {
    font = TTF_OpenFont( "data/font.ttf", 24 );
    if(!font)
    {
      cout << "Font not loaded!\n";
      exitgame(1);
    }
  }
}

void txt()
{
  SDL_Color textColor = { 255, 255, 255 };

  char msg[25];
  sprintf(msg,"%i|%i|%i",playerobj.lives,level,playerobj.score);

  texture = TTF_RenderText_Blended( font, msg, textColor );
  textureb = SDL_CreateRGBSurface(0, 256, 256, 32, 0xff000000, 0x0000ff00, 0x00ff0000, 0x00000000); //FIXME: i cant get 


  SDL_BlitSurface(texture, 0, textureb, 0);

  if(!texture)
  {
    cout << "\nTexture error\n";
    exitgame(1);
  }
  
  if(!texture->pixels)
  {
    cout << "\nNo pixulZ! :(\n";
    exitgame(1);
  }
  
  if(!glTexture[0])
  {
    glGenTextures(1, &glTexture[0]);
  }
  glBindTexture(GL_TEXTURE_2D, glTexture[0]);
  gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA, textureb->w, textureb->h, GL_RGBA, GL_UNSIGNED_BYTE, textureb->pixels);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  SDL_FreeSurface( texture );
  SDL_FreeSurface( textureb );
}


void initGL() {

    printf("GL_RENDERER   = %s\n", (char *) glGetString(GL_RENDERER));
   // printf("GL_VERSION    = %s\n", (char *) glGetString(GL_VERSION));
    printf("GL_VENDOR     = %s\n", (char *) glGetString(GL_VENDOR));
  //  printf("GL_EXTENSIONS = %s\n", (char *) glGetString(GL_EXTENSIONS));

    /* Enable smooth shading */
    glShadeModel( GL_SMOOTH );

    /* Set the background black */
    glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );

    /* Depth buffer setup */
    glClearDepth( 1.0f );

    /* Enables Depth Testing */
    glEnable( GL_DEPTH_TEST );

    /* The Type Of Depth Test To Do */
    glDepthFunc( GL_LEQUAL );
   
    /* Really Nice Perspective Calculations */
    glHint( GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST );

  initGLobjects();

}
#define NUMSTARS 1000
#define STARSTART 3.0f

GLfloat starsy[NUMSTARS];
GLfloat starsx[NUMSTARS];
GLfloat starspeed[NUMSTARS];
GLfloat starh[NUMSTARS];

long lastStarTick=0;

float rndflt(float total, float negative)
{
  
  return (rand()/(float(RAND_MAX)+1)*total)-negative;
}

void initStarField()
{
  int star=0;
  while(star < NUMSTARS)
  {
    starsy[star]=rndflt(6.0f,3.0f);
    starsx[star]=rndflt(6.6f,3.3f); //Random float kthx
    starspeed[star]=rndflt(2.5f,0.0f)+0.1;//rndflt(2,0); //random speed kthx
    starh[star] = rndflt(1.0f,0.0f);

    star++;
  }
}

void glStarfield()
{
  glLoadIdentity();
  glTranslatef( 0.0f, 0.0f, -6.0f );

  int star=0;
  GLfloat distance;
  int ticks = SDL_GetTicks() - lastStarTick;
  
  glPushMatrix();
  glBegin( GL_POINTS );
  while(star<NUMSTARS)
  {
    //Uden for skærmen
    if(starsy[star] <= -3.0f)
    {
      starsy[star]=STARSTART;
      starsx[star]=rndflt(6.6f,3.3f); //Random float kthx
      starspeed[star]=rndflt(2.5f,0.0f)+0.1; //random speed kthx
    }
    else
    {
      //Inden for skærmen
      
    
   
  //  cout << "Star"<< star<< " ("<<starsx[star] << ","<<starsy[star]<<") \n";
    distance = starspeed[star]*(level/2.0f) * (ticks/1000.0f);
    lastStarTick = SDL_GetTicks();
    starsy[star]=starsy[star] - distance;
    }
    glColor3f(starh[star],starh[star],starh[star]);
    glVertex3f( starsx[star], starsy[star], 0.0f );
  
    star++;
  }
  glEnd();
  glPopMatrix();
}




void glScoreboard()
{
  glPushMatrix();
  glLoadIdentity();
  glTranslatef( 2.34f, 2.35f, -6.0f );
  
  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, glTexture[0]);
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glBegin( GL_QUADS );

    glColor3f(1.0f,1.0f,1.0f);

    glTexCoord2f(0.0f, 0.1125f);
    glVertex3f( 0.0f, 0.0f, 0.0f );

    glTexCoord2f(1.0f, 0.1125f);
    glVertex3f( 1.0f, 0.0f, 0.0f );

    glTexCoord2f(1.0f, 0.0f);
    glVertex3f( 1.0f, 0.1125f, 0.0f );

    glTexCoord2f(0.0f, 0.0f);
    glVertex3f( 0.0f, 0.1125f, 0.0f );
  glEnd();
  glDisable(GL_TEXTURE_2D);
  glDisable(GL_BLEND);
  glPopMatrix();
}

void renderAlienRows()
{
  int ar=0;
  nextlevblocks=0;
  aRowTicks = SDL_GetTicks();
  while(ar < alienrows)
  {
    if(arows[ar].active==1)
    {
//      cout << ar << "\n";
      
      if(arows[ar].nextrow==1)
      {
        if(ar < alienrows+1)
        {
          if(arows[ar].nextrow==1)
          {
            if(arows[ar+1].active==0)
            {
              arows[ar].nextrow=0;
              arows[ar].y =arows[ar].y - 0.25f;
            }
          }

        }
      }
      arows[ar].update();
      nextlevblocks = 1;
    }
    ar++;
  }
  aRowLastTick = SDL_GetTicks();
}

void draw()
{

  if(glBlink && !glBlinkOff)
  {
    int ticks = SDL_GetTicks() - drawLastTick;
    
    glClearColor( 1.0f, 0.0f, 0.0f, 0.0f );
    if(ticks > 50)
    {
      glBlink=0;
      glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );
    }
  }

  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

  if(starfield)
  {
    glStarfield();
    lastStarTick = SDL_GetTicks();
  }
    
  //Reset position
  glLoadIdentity();
  glTranslatef( 0.0f, 0.0f, -6.0f );


  renderAlienRows();

  
  int thisbullet=0;
  //Vis bullets...
  while(thisbullet != NUM_BULLETS)
  {
    if(bullets[thisbullet].active == 1)
    {
      glPushMatrix();
      glLoadIdentity();
      glTranslatef( 0.0f, 0.0f, -6.0f );
      bullets[thisbullet].move();
      if(bullets[thisbullet].dir==0)
        glCallList(glAlienBulletMesh);
      else
        glCallList(glPlayerBullet);
      glPopMatrix();
    }
    thisbullet++;
  }

  //Player FIXME: Som det er nu varer det en frame før skibet skyder!
  glPushMatrix();
  glLoadIdentity();
  glTranslatef( 0.0f, 0.0f, -6.0f );
  playerobj.move();
  if(playerobj.lives > 0)
  {
    glBegin( GL_TRIANGLES );
      if(playerobj.shooting)
        glColor3f(1.0f,0.0f,0.0f);
      else
        glColor3f(0.0f,1.0f,1.0f);
      playerobj.shooting=0; 
      glVertex3f( 0.0f, 0.15f,0.0f );
      glColor3f(0.0f,0.0f,1.0f);
      glVertex3f( -0.15f, -0.15f,0.0f);
      glVertex3f(  0.15f, -0.15f,0.0f);
      
      glVertex3f( 0.15f, -0.15f, 0.0f);
      glVertex3f( 0.0f,  -0.15f, 0.0f);
      glVertex3f( 0.20f, -0.25f, 0.f);
      
      glVertex3f( -0.15f, -0.15f, 0.0f);
      glVertex3f( 0.0f,  -0.15f, 0.0f);
      glVertex3f( -0.20f, -0.25f, 0.f);

    glEnd( );
  }
  glPopMatrix();


  //Scoreboard
  glScoreboard();

  renderParticlesystems();

    glPopMatrix();
    /* Draw it to the screen */
    SDL_GL_SwapBuffers( );
}

void initSound()
{
  if(Mix_OpenAudio( 22050, MIX_DEFAULT_FORMAT, 2, 1024 ) == -1)
  {
    cout << "\nUnable to initializing sound\n";
    exitgame(1);
  }
  SND_playerbullet = Mix_LoadWAV( "data/playerbullet.wav" );
  SND_playerhit = Mix_LoadWAV("data/playerhit.wav");
  SND_nmedie = Mix_LoadWAV( "data/nmedie.wav" );
  SND_gameover = Mix_LoadWAV("data/gameover.wav");

  if(SND_playerbullet == NULL)
  { 
    cout << "\nCouldn't load data/playerbullet.wav\n";
    exitgame(1);
  }

  if(SND_playerhit == NULL)
  {
    cout << "\nCouldn't load data/playerhit.wav\n";
    exitgame(1);
  }

  if(SND_nmedie == NULL)
  {
    cout << "\nCouldn't load data/nmedie.wav\n";
    exitgame(1);
  }
  
  if(SND_gameover == NULL)
  {
    cout << "\nCouldn't load data/gameover.wav\n";
    exitgame(1);
  }
}


void spawnPsystem(GLfloat x, GLfloat y, GLfloat scale, int life, GLfloat maxvel) {
int ps=0;
  if(enablePs)
  {
    //Find et system der er ledigt
    while(ps < NUM_PSYS)
    {
      if(psys[ps].liveparticles==0)
      {
        psys[ps].numparticles = NUM_PARTICLES;
        psys[ps].scale = scale;
        psys[ps].ox = x;
        psys[ps].oy = y;
        psys[ps].syslife = life;
        psys[ps].maxvel = maxvel;
        psys[ps].init();
        break;
      }
      ps++;
    }
  }
}

void renderParticlesystems()
{
  int ps=0;
  if(enablePs)
  {
    while(ps < NUM_PSYS)
    {
    // cout << "\n Rendering particles..\n";
      if(psys[ps].liveparticles > 0)
      {
        psys[ps].update();
    //   cout << "rendering live particle..\n";
      }
      ps++;
    }
  }
}

void intro(int playstate)
{
  glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );
  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

  if(starfield)
  {
    glStarfield();
    lastStarTick = SDL_GetTicks();
  }
  


  glPushMatrix();
  glLoadIdentity();
  glTranslatef( 0.0f, 0.0f, -6.0f );

  glEnable(GL_TEXTURE_2D);
  if(playstate==1)
    glBindTexture(GL_TEXTURE_2D, glTexture[1]);
  else if(playstate==2)
    glBindTexture(GL_TEXTURE_2D, glTexture[2]);
  else
    glBindTexture(GL_TEXTURE_2D, glTexture[4]);

  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glBegin( GL_QUADS );

    glColor3f(1.0f,1.0f,1.0f);

    glTexCoord2f( 0.0f, -1.0f );
    glVertex3f( -1.0f, 1.0f, 0.0f );

    glTexCoord2f( 1.0f, -1.0f );
    glVertex3f( 1.0f, 1.0f, 0.0f );

    glTexCoord2f( 1.0f, 0.0f );
    glVertex3f( 1.0f, -1.0f, 0.0f );

    glTexCoord2f( 0.0f, 0.0f );
    glVertex3f( -1.0f, -1.0f, 0.0f );
  glEnd();
  glDisable(GL_TEXTURE_2D);
  
  glDisable(GL_BLEND);
  glPopMatrix();
  
  glScoreboard();
  
  renderParticlesystems();

  SDL_GL_SwapBuffers( );

}

SDL_Joystick *joyA = NULL;
int joysticknr=0;
int playstate = 1;
Sint16 x_move=0, y_move=0;
Uint8 btnA=0;

void handleInputPlaying()
{
  //Ikke flere aliens? Næste bane
  if(nextlevblocks==0)
  {
    level++;;
    playerobj.lives++;
    initGameObjects(0);
    playerbullets=0;
  }
  
  Uint8 *keyStates = SDL_GetKeyState( NULL );
  if(keyStates[SDLK_LEFT])
    playerobj.xvel=-2.5f;
  if(keyStates[SDLK_RIGHT])
    playerobj.xvel=2.5f;
  if(keyStates[SDLK_UP]) 
    playerobj.yvel=2.5f;
  if(keyStates[SDLK_DOWN]) 
    playerobj.yvel=-2.5f;
  if(keyStates[SDLK_LCTRL])
    playerobj.shooting=1;


  if(SDL_JoystickOpened(joysticknr))
  {
    x_move=SDL_JoystickGetAxis(joyA, 0);
    y_move=SDL_JoystickGetAxis(joyA, 1);
    btnA = SDL_JoystickGetButton(joyA,0);

    if(x_move < -200)
      playerobj.xvel=-2.5f;
    if(x_move > 200)
      playerobj.xvel=2.5f;
    if(y_move < -200)
      playerobj.yvel=2.5f;
    if(y_move > 200)
      playerobj.yvel=-2.5f;
    if(btnA)
      playerobj.shooting=1;
  }
}




int main (int argc, char *argv[]) {
bool fullscreen=0;
int resx=1600;
int resy=1200;
int sleepdelay = 10000;

drawLastTick=0;

int arg=0;
while(arg != argc)
{
  if(strcmp(argv[arg],"--nosound") == 0)
  {
    sound=0;
    cout << "\nSound disabled.\n";
  } else if(strcmp(argv[arg],"--fullscreen") == 0)
  {
    fullscreen=1;
  } else if(strcmp(argv[arg],"--noblink") == 0)
  {
    glBlinkOff=1;
    cout << "\nBlinking disabled.\n";
  } else if(strcmp(argv[arg], "--x") == 0)
  {
    arg++; //det er det næste der er spændende
    resx = atoi(argv[arg]);    
  } else if(strcmp(argv[arg], "--y") == 0)
  {
    arg++;
    resy = atoi(argv[arg]);
  } else if(strcmp(argv[arg],"--nostars") == 0) {
    starfield=0;
  } else if(strcmp(argv[arg],"--noparticles") == 0) {
    enablePs=0;
  } else if(strcmp(argv[arg],"--sleep") == 0) {
    arg++;
    sleepdelay = atoi(argv[arg]);
    if(sleepdelay < 10)
      sleepdelay = 1000;
  } else if(strcmp(argv[arg],"--help") == 0 || strcmp(argv[arg],"-help") == 0 || strcmp(argv[arg],"-h") == 0)
  {
    cout << "\nsimplevaders - a space-invaders like game that is nothing like space-invaders.\nUsage:\n  simplevaders [--nosound] [--fullscreen] [--noblink] [--x pixels] [--y pixels] [--nostars] [--noparticles] [--sleep USeconds]\n\nControls:\n s = toggle sound (if enabled)\n f = toggle fullscreen\n a = toggle starfield\n arrows = move ship\n lctrl = shoot\n\nJoystick 0:\n btn0 = shoot\n xy aix.. go figure.\n";
    return(0);
  }
  arg++;
}

if(resx < 1 || resy < 1 || resx > 12000 || resy > 12000)
{
  cout << "\nInvalid resolution:" << resx <<"x" << resy << "\n";
  exitgame(1);
}


  //Initialize SDL
  if(SDL_Init(SDL_INIT_VIDEO|SDL_INIT_TIMER|SDL_INIT_JOYSTICK) <0 )
  {
    printf("\nError: Unable to initialize SDL:%s\n", SDL_GetError());
    exitgame(1);
  }
  
 SDL_ShowCursor(SDL_DISABLE);
  
  //joysticks?
  if(SDL_NumJoysticks() > 0)
  {
    joyA = SDL_JoystickOpen(joysticknr);
    cout << "\n" << SDL_NumJoysticks() << " joysticks found, using '" << SDL_JoystickName(joysticknr) << "' with "<<SDL_JoystickNumButtons(joyA)<<" buttons.\n";
    if(!SDL_JoystickOpened(joysticknr))
      cout << " error opening joystick, no joystick.\n";
    
    SDL_JoystickEventState (SDL_ENABLE);
  }
 
  if(fullscreen)
    screen = SDL_SetVideoMode(resx,resy,32,SDL_OPENGL|SDL_RESIZABLE|SDL_DOUBLEBUF|SDL_FULLSCREEN );  
  else
    screen = SDL_SetVideoMode(resx,resy,32,SDL_OPENGL|SDL_RESIZABLE|SDL_DOUBLEBUF );
  
  if( screen == NULL )
  {
    printf("\nError: Unable to set screen to %ix%i: %s\n",resx,resy,SDL_GetError());
    exitgame(1);
  }

  if(TTF_Init() == -1)
  {
    cout << "\nError: could not init SDL_ttf: "<< TTF_GetError() <<"\n";
    exitgame(1);
  }

  SDL_WM_SetCaption("simplevaders", "simplevaders");

  initGL();
  initTxt();
  initGameObjects(1);
  initStarField();
  
  if(sound)
    initSound();

      /* resize the initial window */
  resizeWindow(resx,resy);
  int done=0;

  while(done == 0)
  { 

    nextlevblocks=0;
    if(playstate==0)
      draw();
    else if(playstate>0)
      intro(playstate);

    if(playstate==0)
      handleInputPlaying();

    while (SDL_PollEvent(&event) )
    {
    
      if( event.type == SDL_QUIT ) { 
        done = 1;
      }
      
      if( event.type == SDL_KEYDOWN ) {
        if(event.key.keysym.sym==SDLK_f)
        {
          if(!fullscreen)
          {
            fullscreen=1;
            screen = SDL_SetVideoMode(resx,resy,32,SDL_OPENGL|SDL_RESIZABLE|SDL_DOUBLEBUF|SDL_FULLSCREEN );
          } else {
            fullscreen=0;
            screen = SDL_SetVideoMode(resx,resy,32,SDL_OPENGL|SDL_RESIZABLE|SDL_DOUBLEBUF );
          }
          resizeWindow(resx,resy);
          if( screen == NULL )
          {
            printf("\nError: Unable to set screen to %ix%i: %s\n",resx,resy,SDL_GetError());
            exitgame(1);
          }
        }
          
        if(event.key.keysym.sym==SDLK_LCTRL && playstate > 0)
        {
          playstate--;
          if(playstate==0)
            newgame();
        }
        
        if( event.key.keysym.sym==SDLK_s)
          sound=!sound;
        
        if( event.key.keysym.sym==SDLK_a)
          starfield=!starfield;
          
        if( event.key.keysym.sym==SDLK_ESCAPE)
        {
          if(playstate==3)
          {
            playstate=4;
          }
          else
          {
            playstate=3;
            spawnPsystem(-2.0, 1.8,1.5, 6000, 2.5);
            spawnPsystem( 2.0, 1.8,1.5, 6000, 2.5);
            spawnPsystem( 2.0,-1.8,1.5, 6000, 2.5);
            spawnPsystem(-2.0,-1.8,1.5, 6000, 2.5);
            spawnPsystem(0.0,0.0,1.5, 6000, 2.5);
          }
        }
          
      }
      
      if( event.type == SDL_VIDEORESIZE ) {
        screen = SDL_SetVideoMode(event.resize.w, event.resize.h,32,SDL_OPENGL|SDL_RESIZABLE|SDL_DOUBLEBUF );
        if( screen == NULL )
        {
          printf("\nError: Unable to set screen to %ix%i: %s\n",resx,resy,SDL_GetError());
          exitgame(1);
        }
        resizeWindow(event.resize.w, event.resize.h);
      }
      
      if(event.type == SDL_JOYBUTTONDOWN)
      {
        if(event.jbutton.button==0 && playstate > 0)
        {
          playstate--;
          if(playstate==0)
            newgame();
        }
      }
    }
    
    if(playstate==4)
      done=1;

    usleep(sleepdelay);
//    SDL_Delay(10);
  }

  exitgame(0);
}

void game_over()
{
  if(sound)
    Mix_PlayChannel(-1, SND_gameover, 0);
    
  spawnPsystem(playerobj.pos[0],playerobj.pos[1]-0.25,3.4f,5000,1.5);
  playstate=2;
}

void newgame()
{
  level=1;
  playerbullets=0;
  initGameObjects(1);
}

void exitgame(bool status) {

  //Free SDL surfaces
  SDL_FreeSurface( screen );
  
  //Free font
  TTF_CloseFont( font );
  
  //Shutdown sdl_ttf
  TTF_Quit();
  
  //Sound
  if(sound) {
    Mix_FreeChunk( SND_playerbullet );
    Mix_FreeChunk( SND_nmedie );
    Mix_FreeChunk( SND_gameover );
    Mix_FreeChunk ( SND_playerhit );
    Mix_CloseAudio();
  }
  
  //Close joysticks
  if(SDL_JoystickOpened(joysticknr))
  {
    SDL_JoystickClose(joyA);
  }
  
  //Shutdown sdl
  SDL_ShowCursor(SDL_ENABLE);
  SDL_Quit();


  if(status)
  {
    cout << "\nExited with errors.\n";
    exit(1);
  } else {
    cout << "\nThanks for playing, come back soon! ;)\nBest score this game was "<< bestScore << " points.\n";
    exit(0);
  }
}
